<?php

if(!defined('_core')) {
exit;
}


/*
HCM modul Archiv 2.0
Autor: Petr Vostrý
Web: http://wall.cz
Parametry (nepovinné):
--------------------
1. ID kategorie. Více kategorií je odděleno čárkami  
2. Robalení archivu: 
   0 = rok 
   1 = rok a měsíce 
příklad: [hcm]moje/archivbox,1-2-4,0[/hcm]
*/


/*--- funkce modulu ---*/
function _get_years($rcond) {
  $result = array();
  $key = 0;     
  $query = DB::query("SELECT id,time FROM `"._mysql_prefix."-articles` AS art".$rcond." ORDER BY time DESC");
  while($item = DB::row($query)){
    $result[$key++] = date("Y", $item['time']);
  }
	return $result;
}

function _get_months($rcond, $year) {
  $result = array();
  $rcond .= " AND time>=".mktime(0,0,0,1,1,$year)." AND time<=".mktime(0,0,0,12,31,$year);
  $key = 0;
  $query = DB::query("SELECT id,time FROM `"._mysql_prefix."-articles` AS art".$rcond." ORDER BY time DESC");
  while($item = DB::row($query)){
    $result[$key] = date("n", $item['time']);
    $key++;
  }
	return $result;
}

function _get_artlink($rcond, $month, $year, $artview) {
  $result = "";
  $lastday = cal_days_in_month(CAL_GREGORIAN, $month, $year);
  $rcond .= " AND time>=".mktime(0,0,0,$month,1,$year)." AND time<=".mktime(0,0,0, $month, $lastday, $year);
  $query = DB::query("SELECT id,title,time FROM `"._mysql_prefix."-articles` AS art".$rcond." ORDER BY time DESC");
  while($item = DB::row($query)){
    $result .= "      <li ".($artview==1?" class='artlink'":"")."><a href='"._linkArticle($item['id'])."' title='".$item['title']."'>".$item['title']."</a></li>\n";
  }
	return $result;
}

function _name_month($month) {
  $name_month = array("", "Leden", "Únor", "Březen", "Duben", "Květen", "Červen", "Červenec", "Srpen", "Září", "Říjen", "Listopad", "Prosinec"); 
  $result = $name_month[$month];
	return $result;
}

/*--- definice funkce modulu ---*/
function _HCM_archiv_archiv($kategorie = null, $zobraz = 0){

    $output = "";
    $artview = intval($zobraz);

    // limitovani na kategorie
    $rcats = _sqlArticleWhereCategories($kategorie);

    // pripojeni casti
    $rcond = " WHERE "._sqlArticleFilter(true);
    if($rcats != "") {$rcond .= " AND ".$rcats;}
    
    $years = _get_years($rcond);
    $roky = array_unique($years);
    $valrok = array_count_values($years);
  
    $output .= "<ul id='nav'>\n"; 
    foreach($roky as $rok){
      $output .= "  <li class='expandable'>".$rok."<span class='cnt'>&nbsp;(".$valrok[$rok].")</span>\n";
      $output .= "  <ul class='block'>\n";
      $months = _get_months($rcond, $rok);
      $mesice = array_unique($months);
      $valmes = array_count_values($months);             
          foreach($mesice as $mesic){
            $output .= "    <li".($artview==1?" class='expandable'":"").">"._name_month($mesic)."<span class='cnt'>&nbsp;(".$valmes[$mesic].")</span>";
            if($artview == 1){
              $output .= "    <ul class='block'>\n";    
              $output .= _get_artlink($rcond, $mesic, $rok, $artview);
              $output .= "    </ul>\n";
            } else {
              $output .= "    <ul class='block'>\n";
              $output .= _get_artlink($rcond, $mesic, $rok, $artview);
              $output .= "    </ul>\n";
            }    
            $output .= "    </li>\n";
          }
      $output .= "  </ul>\n";        
      $output .= "  </li>\n"; 
    }    
    $output .= "</ul>\n";

  return $output;
  
}

?>